; ##############################################################################
; ##############################################################################
; ##############################################################################
;														
; ADC initialisieren mit "Free Run" und Vorteiler		
;														
; 	ADEN: ADC Enable                             		
; 	ADSC: ADC Start Conversion                   		
; 	ADFR: ADC Free Running Select                		
; 	ADIF: ADC Interrzpt Flag                     		
; 	ADIE: ADC Interrupt Enable                   		
; 	ADPS2: Vorteiler                             		
; 	ADPS2: Vorteiler                             		
; 	ADPS2: Vorteiler                             		
;														
;	ADPS2 ADPS1 ADPS0 Division Factor					
;	0 		0 	0 		2								
;	0 		0 	1 		2								
;	0 		1 	0 		4								
;	0 		1 	1 		8								
;	1 		0 	0 		16								
;	1 		0 	1	 	32								
; *	1 		1 	0 		64								
;	1 		1 	1 		128								
;														
;																					
; ADC REFERENZ																		
;																					
; REFS1 REFS0 Voltage Reference Selection											
;  0     0    AREF, Internal Vref turned off										
; *0     1    AVCC with external capacitor at AREF pin								
;  1     1    Internal 2.56V Voltage Reference with external capacitor at AREF pin	
ADC_INITIALISIERUNG:
	ldi temp, (1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(0<<ADPS2)|(1<<ADPS1)|(0<<ADPS0) 
	out ADCSR, temp

	ldi temp, (0<<REFS1)|(1<<REFS0)
	out ADMUX, temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ADC_OFF:
	out ADCSR, NULL
	out ADMUX, NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; MUX3..0 Single Ended Input
; 0000 ADC0
; 0001 ADC1
; 0010 ADC2
; 0011 ADC3
; 0100 ADC4
; 0101 ADC5
; 0110 ADC6
; 0111 ADC7
; 1110 1.23V (VBG)
; 1111 0V (GND)
ADC_MESSEN_VBG_TEMP1:
	ldi temp, (0<<REFS1)|(1<<REFS0)|(0<<ADLAR)|(1<<MUX3)|(1<<MUX2)|(1<<MUX1)|(0<<MUX0)
	out ADMUX, temp
	rcall ADC_MESSEN_TEMP1_2			; OUT: TEMP1 / TEMP2	

	LSR temp2
	ROR temp1

	LSR temp2
	ROR temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ADC-WERT 256 mal einlesen und daraus den Mittelwert bilden					
;																				
; OUT: 	TEMP1 (low)  															
;		TEMP2																	
; 																				
ADC_MESSEN_TEMP1_2:
; neuen ADC-Wert lesen	 Wert verwerfen, da meist vom vorherigem ADC-Kanal	
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !
;-------------------------------------------------------------------
ADC_MESSEN_s1:                  
	sbis ADCSRA, ADIF			; warten bis ADIF flag gesetzt	
	rjmp ADC_MESSEN_s1
	sbi ADCSRA, ADIF    		; logisch "1" lscht ADIF flag !
;-------------------------------------------------------------------
ADC_MESSEN_s2:                
	sbis ADCSR, ADIF 			; warten bis ADIF flag gesetzt	
	rjmp ADC_MESSEN_s2
;-------------------------------------------------------------------------------
	in  temp1, ADCL 			; immer zuerst LOW Byte lesen
	in  temp2, ADCH 			; danach das mittlerweile gesperrte High Byte
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ADC_ANZEIGE_BETRIEBSSPANNUNG:
	rcall ADC_INITIALISIERUNG
;-------------------------------------------------------------------------------
	ldi temp9,100
ADC_ANZEIGE_s:
	rcall ADC_MESSEN_VBG_TEMP1
	rcall ADC_LED_TEMP1
	rcall WAIT_5ms
	dec temp9
	brne ADC_ANZEIGE_s
;-------------------------------------------------------------------------------
	rcall ADC_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ADC_LED_TEMP1:
.equ VBG=1230
.equ ADCmax=(1024/4)

.equ AdcSchwelle19=4800
.equ AdcSchwelle18=4600
.equ AdcSchwelle17=4400
.equ AdcSchwelle16=4200
.equ AdcSchwelle15=4000
.equ AdcSchwelle14=3800
.equ AdcSchwelle13=3600
.equ AdcSchwelle12=3400
.equ AdcSchwelle11=3200
.equ AdcSchwelle10=3000


.equ AdcSchwelle9=2900
.equ AdcSchwelle8=2800
.equ AdcSchwelle7=2700
.equ AdcSchwelle6=2600
.equ AdcSchwelle5=2500
.equ AdcSchwelle4=2400
.equ AdcSchwelle3=2300
.equ AdcSchwelle2=2200
.equ AdcSchwelle1=2100
.equ AdcSchwelle0=2000


	cpi temp1,(VBG*ADCmax/AdcSchwelle19);
	brlo ADC_LED19
	cpi temp1,(VBG*ADCmax/AdcSchwelle18);
	brlo ADC_LED18
	cpi temp1,(VBG*ADCmax/AdcSchwelle17);
	brlo ADC_LED17
	cpi temp1,(VBG*ADCmax/AdcSchwelle16);
	brlo ADC_LED16
	cpi temp1,(VBG*ADCmax/AdcSchwelle15);
	brlo ADC_LED15
	cpi temp1,(VBG*ADCmax/AdcSchwelle14);
	brlo ADC_LED14
	cpi temp1,(VBG*ADCmax/AdcSchwelle13);
	brlo ADC_LED13
	cpi temp1,(VBG*ADCmax/AdcSchwelle12);
	brlo ADC_LED12
	cpi temp1,(VBG*ADCmax/AdcSchwelle11);
	brlo ADC_LED11
	cpi temp1,(VBG*ADCmax/AdcSchwelle10);
	brlo ADC_LED10	
;-------------------------------------------------------------------------------
	cpi temp1,(VBG*ADCmax/AdcSchwelle9);
	brlo ADC_LED9
	cpi temp1,(VBG*ADCmax/AdcSchwelle8);
	brlo ADC_LED8
	cpi temp1,(VBG*ADCmax/AdcSchwelle7);
	brlo ADC_LED7
	cpi temp1,(VBG*ADCmax/AdcSchwelle6);
	brlo ADC_LED6
	cpi temp1,(VBG*ADCmax/AdcSchwelle5);
	brlo ADC_LED5
	cpi temp1,(VBG*ADCmax/AdcSchwelle4);
	brlo ADC_LED4
	cpi temp1,(VBG*ADCmax/AdcSchwelle3);
	brlo ADC_LED3
	cpi temp1,(VBG*ADCmax/AdcSchwelle2);
	brlo ADC_LED2
	cpi temp1,(VBG*ADCmax/AdcSchwelle1);
	brlo ADC_LED1
	cpi temp1,(VBG*ADCmax/AdcSchwelle0);
	brlo ADC_LED0	
	LED_ROT_ON	
	ret
;-------------------------------------------------------------------------------
ADC_LED19:	rjmp BAR_BAND19
ADC_LED18:	rjmp BAR_BAND18
ADC_LED17:	rjmp BAR_BAND17
ADC_LED16:	rjmp BAR_BAND16
ADC_LED15:	rjmp BAR_BAND15
ADC_LED14:	rjmp BAR_BAND14
ADC_LED13:	rjmp BAR_BAND13
ADC_LED12:	rjmp BAR_BAND12
ADC_LED11:	rjmp BAR_BAND11
ADC_LED10:  rjmp BAR_BAND10
;-------------------------------------------------------------------------------
ADC_LED9:	rjmp BAR_BAND9
ADC_LED8:	rjmp BAR_BAND8
ADC_LED7:	rjmp BAR_BAND7
ADC_LED6:	rjmp BAR_BAND6
ADC_LED5:	rjmp BAR_BAND5
ADC_LED4:	rjmp BAR_BAND4
ADC_LED3:	rjmp BAR_BAND3
ADC_LED2:	rjmp BAR_BAND2
ADC_LED1:	rjmp BAR_BAND1
ADC_LED0:  	rjmp BAR_BAND0
; ##############################################################################
; ##############################################################################
; ##############################################################################


