; ##############################################################################
; ##############################################################################
; ##############################################################################
STARTWERTE:
	; NULL				
	clr NULL
	; Eins				
	ldi temp,1
	mov EINS,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; TIMER				
	mov ssVT_L, EINS
	mov ssVT_H, NULL

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
WDR_INITIALISIERUNG:
; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;  Bit 3  WDRF: Watchdog Reset Flag											
; This bit is set if a Watchdog Reset occurs. The bit is reset by a Power-on Reset, or by
; writing a logic zero to the flag.												
;  Bit 2  BORF: Brown-out Reset Flag											
; This bit is set if a Brown-out Reset occurs. The bit is reset by a Power-on Reset, or by
; writing a logic zero to the flag.												
;  Bit 1  EXTRF: External Reset Flag											
; This bit is set if an External Reset occurs. The bit is reset by a Power-on Reset, or by
; writing a logic zero to the flag.												
;  Bit 0  PORF: Power-on Reset Flag											
WDR_NEUSTART:
	WDR
	in temp, MCUCSR
	andi temp,(0<<WDRF)|(0<<BORF)|(0<<EXTRF)|(0<<PORF) 
	tst temp
	brne WDR_NEUSTART_RES
	; MCUCSR clear		
	ldi temp,0
	out MCUCSR,temp
	ret
;-------------------------------------------------------------------
WDR_NEUSTART_RES:
	rjmp WDR_NEUSTART_RES
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
REGISTER_CLEAR:
	clr R0
	clr R1
	clr R2
	clr R3
	clr R4
	clr R5
	clr R6
	clr R7
	clr R8
	clr R9
	clr R10
	clr R11
	clr R12
	clr R13
	clr R14
	clr R15
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PORTS_CLEAR:
	clr temp		; PORT B+C+D auf EINGANG
	out DDRB, temp
	out DDRC, temp
	out DDRD, temp
	ldi temp,0xFF	; Pull-Up on			
	out PORTB,temp	
	out PORTC,temp				
	out PORTD,temp				
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER
	ret
;-------------------------------------------------------------------------------
PROGRAMM_CHECK_FEHLER:
	rjmp PROGRAMM_ERROR
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_INITIALISIERUNG:
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)
	sbi (LED_GELB_DDR) ,(LED_GELB_PIN_NR)
	sbi (LED_ROT_DDR)  ,(LED_ROT_PIN_NR)
	sbi (BEEP_DDR)     ,(BEEP_PIN_NR)
;-------------------------------------------------------------------------------
	BEEP_ON
	rcall WAIT_10ms
	BEEP_OFF
;-------------------------------------------------------------------------------
	LED_GRUEN_ON
	rcall WAIT_50ms
	LED_GRUEN_OFF
;-------------------------------------------------------------------------------
	LED_GELB_ON
	rcall WAIT_50ms
	LED_GELB_OFF
;-------------------------------------------------------------------------------
	LED_ROT_ON
	rcall WAIT_50ms
	LED_ROT_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_KURZ:
	BEEP_ON
	rcall WAIT_10ms
	BEEP_OFF
ret
; ##############################################################################
BEEP_LANG:
	BEEP_ON
	rcall WAIT_100ms
	BEEP_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LED_ANZEIGE_TEMP1:

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
