;														
; Windmesser-Bargraph 									
; 20x LED												
; 10/2019												
; Bernhard.Erfurt@gmx.de								
; https://www.mikrocontroller.net/topic/480843#new		
;														

; Blinken die LEDs, das ist nicht gut !									
; ROT blinkt: 				Fehler im Programmcheck						
; ROT+GELB blinken: 		WDR-Zeitberschreitung						
; ROT+GELB+GRN blinken: 	unkorrekter Interruptaufruf

; ATmega8 										
.include "m8def.inc"
.include "MACROS.asm"					; Macros
.equ TAKT					=1000000	; 1 MHz	
; WINDMESSER															
; Wind		Frequenz													
; 0 km/h	0 Hz														
; 10 km/h	16 Hz														
; 20 km/h	32 Hz														
; 30 km/h	48 Hz														
; 40 km/h	64 Hz														
; 50 km/h	80 Hz														
; 60 km/h	96 Hz														
; 70 km/h	112 Hz														
; 80 km/h	128 Hz														
; 90 km/h	144 Hz														
; 100 km/h	160 Hz														
.equ WIND100 =160				; Frequenz bei 100km/h	

.equ SCHWELLE0=WIND100*2/100	; 2km/h
.equ SCHWELLE1=WIND100*4/100
.equ SCHWELLE2=WIND100*6/100
.equ SCHWELLE3=WIND100*8/100
.equ SCHWELLE4=WIND100*10/100
.equ SCHWELLE5=WIND100*12/100
.equ SCHWELLE6=WIND100*14/100
.equ SCHWELLE7=WIND100*16/100
.equ SCHWELLE8=WIND100*18/100
.equ SCHWELLE9=WIND100*20/100
.equ SCHWELLE10=WIND100*22/100
.equ SCHWELLE11=WIND100*24/100
.equ SCHWELLE12=WIND100*26/100
.equ SCHWELLE13=WIND100*28/100
.equ SCHWELLE14=WIND100*30/100
.equ SCHWELLE15=WIND100*32/100
.equ SCHWELLE16=WIND100*34/100
.equ SCHWELLE17=WIND100*36/100
.equ SCHWELLE18=WIND100*38/100
.equ SCHWELLE19=WIND100*40/100	; 40km/h	
.equ SCHWELLE_MAX=WIND100*42/100; 42km/h	
; WINDMESSER									
.equ WIND_PIN_NR			= 5
.equ WIND_PIN				= PINC
.equ WIND_DDR				= DDRC
.equ WIND_PORT				= PORTC
; BEEP										
.equ BEEP_PIN_NR			= 0
.equ BEEP_DDR				= DDRD
.equ BEEP_PORT				= PORTD
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR		= 2
.equ LED_GRUEN_DDR			= DDRD
.equ LED_GRUEN_PORT			= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR		= 3
.equ LED_GELB_DDR			= DDRD
.equ LED_GELB_PORT			= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR			= 4
.equ LED_ROT_DDR			= DDRD
.equ LED_ROT_PORT			= PORTD



; REGISTER										
.def TIMERZAHL 		= R7
.def ROHDATA 		= R8
.def IMPULSE 		= R9
.def FREQUENZ 		= R10
.def FREQUENZ_MAX 	= R11

.def ssVT_L 	= R12
.def ssVT_H 	= R13

.def NULL		= R14
.def EINS		= R15

.def temp 		= R16
.def temp1 		= R17
.def temp2 		= R18
.def temp3 		= R19
.def temp4 		= R20
.def temp5 		= R21
.def temp6 		= R22
.def temp7 		= R23
.def temp8 		= R24
.def temp9 		= R25
; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					=SRAM_START+0		; 0x0060 START Adresse 		
.equ adr_FREIGABE				=SRAM_START+10


.equ adr_SRAM_CHECK				=SRAM_START+943	; SRAM CHECK muss immer "S" sein	

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp TIM2_OVF   		; Timer2 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;TIM1_OVF   	  	; Timer1 Overflow Handler           
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   		; Timer0 Overflow Handler       
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	LED_ROT_ON
	LED_GELB_ON
	LED_GRUEN_ON
	rcall WAIT_100ms
	LED_ROT_OFF
	LED_GELB_OFF
	LED_GRUEN_OFF
	rcall WAIT_100ms
	rjmp INTERRUPT_ERROR
;Programm-Error										
PROGRAMM_ERROR:
	LED_ROT_ON
	rcall WAIT_100ms
	LED_ROT_OFF
	LED_GELB_OFF
	LED_GRUEN_OFF
	rcall WAIT_100ms
	rjmp PROGRAMM_ERROR
RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
	rcall SRAM_CLEAR
	rcall REGISTER_CLEAR
	rcall PORTS_CLEAR
	rcall LED_INITIALISIERUNG
	rcall BAR_INITIALISIERUNG
	rcall STARTWERTE
	rcall WDR_INITIALISIERUNG
	rcall WIND_INITIALISIEREN
	rcall TIMER2_INITIALISIEREN_ASYNCRON_1ms
	rcall TIMER_AKTIVIEREN
	rcall SLEEP_EXT_INTERRUPT_INITIALISIEREN
	sei			; Interrupts freigeben								
;-------------------------------------------------------------------
	rcall WIND_CLEAR
	rcall WAIT_100ms
	rcall BAR_TEST
	rcall ADC_ANZEIGE_BETRIEBSSPANNUNG
	rcall SLEEP_1s
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	rcall SLEEP_1ms
;-------------------------------------------------------------------
	LDS temp,(adr_FREIGABE)
	tst temp
	breq LOOP
;-------------------------------------------------------------------
	STS(adr_FREIGABE),NULL
	rcall WIND_MAX_BERECHNUNG
	tst FREQUENZ_MAX
	breq LOOP_w
	rcall WIND_ANZEIGE
	rcall PROGRAMM_CHECK
	rjmp LOOP
;-------------------------------------------------------------------
LOOP_w:
	LED_GRUEN_ON
	rcall SLEEP_1ms		; Lebenslicht	
	LED_GRUEN_OFF
	rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "TIMER.asm"			; TIMER							
.include "WIND.asm"				; Windsensor					
.include "SONSTIGES.asm"		; sonstiges						
.include "WAIT.asm"				; 1 MHz							
.include "ADC.asm"				; ADC							
.include "BARGRAPH.asm"			; Bargraph						



